* filename : 12creg.inc *
* -contains all memory registers in the program *


;************************************************
; VARIABLES DP = ??
;************************************************      	
			.align 128
_I2C_DP		.usect "data",0
_I2CSTATUS	.usect "data",1

*ODBYTECTR
*Output data btye counter
*	+---------------------------------------------+
*	|15		 			8 | 7					0 |
*   +---------------------------------------------+
*	|  Current byte		  |       Number of 	  |
*	|	pointer		      |		    byte 		  |
*   +---------------------------------------------+
*   byte pointer : 8bits . because reserved 255 words
*ODBITCTR
*Output data bIT counter
*	+-----------------------------+
*	|15		       4  | 3		0 |
*   +-----------------------------+
*	|  XXXXX		  |    Bit    |
*	|                 |  pointer  |
*   +-----------------------------+
*   bit pointer : 3bits . for byte

_ODBYTECTR	.usect "data", 1
ODBITCTR    .usect "data", 1

*IDCTR
*Input data btye/bit counter
*	+---------------------------------------------+
*	|15		 			8 | 7					0 |
*   +---------------------------------------------+
*	|  Current byte		  |       Number of 	  |
*	|	pointer		      |		    byte 		  |
*   +---------------------------------------------+
*   byte pointer : 8bits . because reserved 255 words
*IDBITCTR    .
*Input data bIT counter
*	+-----------------------------+
*	|15		       4  | 3		0 |
*   +-----------------------------+
*	|  XXXXX		  |    Bit    |
*	|                 |  pointer  |
*   +-----------------------------+
*   bit pointer : 3bits . for byte
_IDBYTECTR	.usect "data",1
IDBITCTR    .usect "data",1
ERRORCODE	.usect "data",1    
_SLAVE_ADDR	.usect "data",1    
TEMP_REG	.usect "data",1			             
POINTER		.usect "data",1      	
TEMP1_REG	.usect "data",1    
*ODPTR
*Output data address pointer register (16bits)
*reserved 255 words (uses only 8 bits)
*	+---------------------------------------------+
*	|15											0 |
*   +---------------------------------------------+
*	| 		  Address of output data		  	  |
*   +---------------------------------------------+
			.align 128
_ODPTR		.usect "data", 0ffh  

*IDPTR
*Input data address pointer register
*reserved 255 words (uses only 8 bits)
*	+---------------------------------------------+
*	|15											0 |
*   +---------------------------------------------+
*	| 		  Address of input data			  	  |
*   +---------------------------------------------+
            .align 128
IDPTR		.usect "data", 0ffh








