* filename : main.asm*
* -an example to test the I2C data transfer using EEPROM, its address *
*  is defined in i2c.inc K_SLAVEADDR *

     .mmregs               
     .def start
     .ref _INIT_PLL,_ODBYTECTR,_IDBYTECTR,_ODPTR
     .ref _init_gpio,_init_i2c,_write_i2c,_read_i2c
     .def _USER_FUNCTION
      		
			
LEN  .set	400         			;Length of stack segment
BOS	 .usect "STK",LEN

;************************************************************************
; MAIN ROUTINE
;************************************************************************
     .text          
start:    
	 STM	#BOS+LEN,SP             ;Setup stack pointer
     CALL	_INIT_PLL               ;Init CPU clock
     RSBX	SXM						;sign extension suppressed
     NOP                
     CALL	_init_gpio              ;Init McBSP to GPIO
     CALL	_init_i2c               ;Init I2C data transfer
;************************************************************************

;********SET UP SLAVE ADDR AND WRITE DATA (DATA MUST BE BYTE!!!)*********    
     CALL	_init_i2c               ;Init I2C data transfer
     STM	#_ODPTR+1,AR2          	;1ST loc at odptr contains slave addr
     ST		#0,*AR2+				;Word addr 00h to 2nd location
     ST     #011H,*AR2+				;Store 11h to EEPROM addr 00h 
     ST     #012H,*AR2+			 	;Store 12h to EEPROM addr 01h 
     ST     #013H,*AR2+				;Store 13h to EEPROM addr 02h 
     ST     #014H,*AR2+				;Store 14h to EEPROM addr 03h
     ST     #015H,*AR2+				;Store 15h to EEPROM addr 04h 
     ST     #016H,*AR2+				;Store 16h to EEPROM addr 05h 
     STM	#_ODBYTECTR,AR1
	 ST		#7,*AR1					;4 bytes to be send including slave addr
	 CALL	_write_i2c 				;write and enable global interrupt

     CALL	Delay                   ;Allows for E/W cycle of EEPROM

;*********SET UP EEPROM WORD ADDRESS*************************************
	 CALL	_init_i2c               ;Init I2C data transfer
	 STM	#_ODPTR+1,AR1           ;1ST loc at odptr contains slave addr
     ST		#0,*AR1+				;Word addr 00h to 2nd location
     NOP
     STM	#_ODBYTECTR,AR1
     ST		#1,*AR1					;2 bytes to be send including slave addr
	 CALL	_write_i2c	     		;write and enable global interrupt

	 CALL	Delay                   ;Allows for E/W cycle of EEPROM
     

;*********READ 4 BYTES FROM EEPROM***************************************
	 CALL	_init_i2c               ;Init I2C data transfer
	 STM	#_IDBYTECTR,AR1	        ;1ST loc at odptr contains slave addr
     ST		#6,*AR1			        ;Read in 2 byte            
     CALL	_read_i2c  				;read and enable global interrupt


;*********End of program*************************************************
STOPSTOP:
		B	STOPSTOP                                
		
;************************************************************************	
;***OTHER SUBROUTINES****************************************************			
;************************************************************************			
Delay:     
		NOP
		PSHM	AR5
		PSHM	AR6
		NOP
		STM		#2000,AR5
LOOP1:	STM		#2000,AR6
LOOP2:  NOP
	    NOP
		BANZ	LOOP2,*AR6-
		BANZ	LOOP1,*AR5-	  
		NOP
		POPM	AR6
		POPM	AR5
		NOP
		RET
;************************************************************************	
;************************************************************************			
_USER_FUNCTION:
		NOP
		RET
			
      .end